/*
 *  BigButtonViewController.m
 *  WhirlyGlobeTester
 *
 *  Created by Steve Gifford on 11/12/11.
 *  Copyright 2011 mousebird consulting
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */

#import "BigButtonViewController.h"

@implementation BigButtonViewController

@synthesize delegate;

+ (BigButtonViewController *)loadFromNib
{
    BigButtonViewController *viewC = [[BigButtonViewController alloc] initWithNibName:@"BigButtonView" bundle:nil];
    
    return viewC;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    self.title = @"Big Button";
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return YES;
}

// Button was pressed.  Notify the delegate
- (IBAction)buttonPress:(id)sender
{
    [delegate bigButtonPushed:self];
}

@end
