/*
 *  SceneRendererES3.h
 *  WhirlyGlobeLib
 *
 *  Created by Steve Gifford on 4/23/14.
 *  Copyright 2011-2017 mousebird consulting
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */

#import "SceneRendererES2.h"

#import <OpenGLES/ES3/gl.h>
#import <OpenGLES/ES3/glext.h>

/** OpenGL ES 3.0 support.
  */
@interface WhirlyKitSceneRendererES3 : WhirlyKitSceneRendererES2

// Will try to make an OpenGL ES 3.0 renderer.  May fail and if it does
//  then create a 2.0 version
- (id)init;

// Initialize an offline renderer of the given size
- (id)initWithSize:(CGSize)size;

@end
